"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// Imports: Dependencies
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_modal_1 = __importDefault(require("react-native-modal"));
const Ionicons_1 = __importDefault(require("react-native-vector-icons/Ionicons"));
// Screen Dimensions
const { height, width } = react_native_1.Dimensions.get('window');
;
// Component: State Picker
exports.StatePicker = (props) => {
    // React Hooks: State
    const [modalVisible, toggle] = react_1.useState(false);
    const [state, setState] = react_1.useState();
    // United States
    const unitedStates = [
        { label: 'AL', value: 'AL' },
        { label: 'AK', value: 'AK' },
        { label: 'AZ', value: 'AZ' },
        { label: 'AR', value: 'AR' },
        { label: 'CA', value: 'CA' },
        { label: 'CO', value: 'CO' },
        { label: 'CT', value: 'CT' },
        { label: 'DE', value: 'DE' },
        { label: 'FL', value: 'FL' },
        { label: 'GA', value: 'GA' },
        { label: 'HI', value: 'HI' },
        { label: 'ID', value: 'ID' },
        { label: 'IL', value: 'IL' },
        { label: 'IN', value: 'IN' },
        { label: 'IA', value: 'IA' },
        { label: 'KS', value: 'KS' },
        { label: 'KY', value: 'KY' },
        { label: 'LA', value: 'LA' },
        { label: 'ME', value: 'ME' },
        { label: 'MD', value: 'MD' },
        { label: 'MA', value: 'MA' },
        { label: 'MI', value: 'MI' },
        { label: 'MN', value: 'MN' },
        { label: 'MS', value: 'MS' },
        { label: 'MO', value: 'MO' },
        { label: 'MT', value: 'MT' },
        { label: 'NE', value: 'NE' },
        { label: 'NV', value: 'NV' },
        { label: 'NH', value: 'NH' },
        { label: 'NJ', value: 'NJ' },
        { label: 'NM', value: 'NM' },
        { label: 'NY', value: 'NY' },
        { label: 'NC', value: 'NC' },
        { label: 'ND', value: 'ND' },
        { label: 'OH', value: 'OH' },
        { label: 'OK', value: 'OK' },
        { label: 'OR', value: 'OR' },
        { label: 'PA', value: 'PA' },
        { label: 'RI', value: 'RI' },
        { label: 'SC', value: 'SC' },
        { label: 'SD', value: 'SD' },
        { label: 'TN', value: 'TN' },
        { label: 'TX', value: 'TX' },
        { label: 'UT', value: 'UT' },
        { label: 'VT', value: 'VT' },
        { label: 'VA', value: 'VA' },
        { label: 'WA', value: 'WA' },
        { label: 'WV', value: 'WV' },
        { label: 'WI', value: 'WI' },
        { label: 'WY', value: 'WY' },
    ];
    // Toggle Modal
    const toggleModal = () => {
        try {
            // Check Platform (iOS)
            if (react_native_1.Platform.OS === 'ios') {
                // React Hook: Toggle Modal
                toggle((modalVisible) => !modalVisible);
            }
            // Check Platform (Android)
            if (react_native_1.Platform.OS === 'android') {
            }
        }
        catch (error) {
            console.log(error);
        }
    };
    // Select State
    const selectState = (state) => {
        try {
            // React Hook: Set State
            setState(state);
            // React Props: onValueChange
            props.onValueChange(state);
        }
        catch (error) {
            console.log(error);
        }
    };
    // Render iOS Picker
    const renderIOSPicker = () => {
        try {
            return (react_1.default.createElement(react_native_1.Picker, { selectedValue: state, onValueChange: () => selectState(state) }, unitedStates.map((item) => {
                return (react_1.default.createElement(react_native_1.Picker.Item, { label: item.label, value: item.value, key: item.key || item.label }));
            })));
        }
        catch (error) {
            console.log(error);
        }
    };
    // Render Platform
    const renderPlatform = () => {
        try {
            // Check Platform (iOS)
            if (react_native_1.Platform.OS === 'ios') {
                return (react_1.default.createElement(react_native_1.View, { style: styles.container },
                    react_1.default.createElement(react_native_1.View, { style: styles.inputTitleContainer },
                        react_1.default.createElement(react_native_1.Text, { style: styles.inputTitle }, "State")),
                    react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => toggleModal(), style: styles.fieldTextContainer },
                        react_1.default.createElement(react_native_1.Text, { style: styles.fieldText }, state !== undefined ? state : 'Select'),
                        react_1.default.createElement(Ionicons_1.default, { name: "ios-arrow-forward", size: 22, style: styles.arrowForward })),
                    react_1.default.createElement(react_native_modal_1.default, { isVisible: modalVisible, style: styles.modal },
                        react_1.default.createElement(react_native_1.View, { style: styles.modalContainer },
                            react_1.default.createElement(react_native_1.View, { style: styles.pickerHeaderContainer },
                                react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => toggleModal() },
                                    react_1.default.createElement(react_native_1.Text, { style: styles.doneText }, "Done"))),
                            react_1.default.createElement(react_native_1.View, { style: styles.pickerContainer }, renderIOSPicker())))));
            }
            // Check Platform (Android)
            if (react_native_1.Platform.OS === 'android') {
                return (react_1.default.createElement(react_native_1.View, { style: styles.container },
                    react_1.default.createElement(react_native_1.View, { style: styles.inputTitleContainer },
                        react_1.default.createElement(react_native_1.Text, { style: styles.inputTitle }, "State")),
                    react_1.default.createElement(react_native_1.View, { style: styles.fieldTextContainer },
                        react_1.default.createElement(react_native_1.Picker, { selectedValue: state, style: { height: 60, width: width - 16 }, onValueChange: () => selectState(state) }, unitedStates.map((item) => {
                            return (react_1.default.createElement(react_native_1.Picker.Item, { label: item.label, value: item.value, key: item.key || item.label, color: item.color }));
                        })))));
            }
        }
        catch (error) {
            console.log(error);
        }
    };
    return (react_1.default.createElement(react_native_1.View, null, renderPlatform()));
};
// Styles
const styles = react_native_1.StyleSheet.create({
    container: {
        display: 'flex',
        width: width - 32,
        justifyContent: 'center',
        marginLeft: 16,
        marginRight: 16,
    },
    modal: {
        margin: 0,
    },
    modalContainer: {
        height: '100%',
        alignItems: 'center',
        justifyContent: 'flex-end',
    },
    pickerHeaderContainer: {
        display: 'flex',
        flexDirection: 'row',
        justifyContent: 'flex-end',
        alignItems: 'center',
        height: 40,
        width: width,
        backgroundColor: '#FAFAF8',
        borderColor: '#7D7D7D',
        borderBottomWidth: react_native_1.StyleSheet.hairlineWidth,
    },
    pickerContainer: {
        height: 220,
        width: width,
        // backgroundColor: '#CFD3D9',
        backgroundColor: 'white',
    },
    doneText: {
        fontFamily: 'System',
        color: '#007AFF',
        fontWeight: '600',
        fontSize: 17,
        marginRight: 16,
    },
    stateContainer: {
        alignItems: 'center',
        width: 75,
        borderColor: '#7D7D7D',
        borderBottomWidth: react_native_1.StyleSheet.hairlineWidth,
    },
    inputTitleContainer: {
        width: 75,
        marginBottom: 4,
    },
    inputTitle: {
        color: '#7D7D7D',
        borderColor: '#7D7D7D',
        fontSize: 10,
        fontWeight: '600',
        textTransform: 'uppercase',
    },
    fieldTextContainer: {
        height: 40,
        display: 'flex',
        flexDirection: 'row',
        justifyContent: 'space-between',
        alignItems: 'center',
        marginBottom: 4,
        borderColor: '#7D7D7D',
        borderBottomWidth: react_native_1.StyleSheet.hairlineWidth,
    },
    fieldText: {
        width: width - 32 - 20,
        fontFamily: 'System',
        fontSize: 17,
        fontWeight: '400',
        color: '#000000',
        alignSelf: 'center',
    },
    arrowForward: {
        color: 'black',
        opacity: .3,
        marginRight: 7,
    },
});
